VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "CD-ROM DETECTION"
   ClientHeight    =   1770
   ClientLeft      =   2070
   ClientTop       =   3180
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   Picture         =   "LeifenCD.frx":0000
   ScaleHeight     =   1770
   ScaleWidth      =   6120
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Command1 
      Caption         =   "Exit"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   1440
      Width           =   5895
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   855
      Left            =   0
      TabIndex        =   0
      Top             =   960
      Width           =   4095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6



Function StripNulls(startStrg$) As String

'Take a string separated by Chr$(0)'s, and split off 1 item, and
'shorten the string so that the next item is ready for removal.

  Dim c%, item$
  c% = 1
  
  Do

    If Mid$(startStrg$, c%, 1) = Chr$(0) Then
      
      item$ = Mid$(startStrg$, 1, c% - 1)
      startStrg$ = Mid$(startStrg$, c% + 1, Len(startStrg$))
      StripNulls$ = item$
      Exit Function
    
    End If

    c% = c% + 1

  Loop

End Function

Private Sub Command1_Click()
End
End Sub

Private Sub Form_Load()

Dim r&, allDrives$, JustOneDrive$, pos%, DriveType&
Dim CDfound As Integer
   
  'pad the string with spaces
   allDrives$ = Space$(64)
  
  'call the API to get the string containing all drives
   r& = GetLogicalDriveStrings(Len(allDrives$), allDrives$)
  
  'trim off trailing chr$(0)'s.  AllDrives$
  'now contains all the drive letters.
   allDrives$ = Left$(allDrives$, r&)
   
  'begin a loop
   Do
      
     'find the first separating chr$(0)
      pos% = InStr(allDrives$, Chr$(0))
      
     'if there's one, then...
      If pos% Then
        
       'extract the drive up to the chr$(0)
        JustOneDrive$ = Left$(allDrives$, pos%)
        
       'and remove that from the Alldrives string,
       'so it won't be checked again
        allDrives$ = Mid$(allDrives$, pos% + 1, Len(allDrives$))
      
       'with the one drive, call the API to
       'determine the drive type
        DriveType& = GetDriveType(JustOneDrive$)
        
       'check if it's what we want
        If DriveType& = DRIVE_CDROM Then
          
          'got it (or at least the first one,
          'anyway, if more than one), so set
          'the found flag...
           CDfound% = True

          'we're done, so get out
           Exit Do
        
        End If
      End If
   
  Loop Until allDrives$ = "" Or DriveType& = DRIVE_CDROM
   
 'display the appropriate message
  If CDfound% Then
        Label1 = "The CD-ROM drive on your system is drive " & UCase$(JustOneDrive$)
  Else: Label1 = "No CD-ROM drives were detected on your system."
  End If

End Sub
